// exampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "example.h"
#include "exampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog

CExampleDlg::CExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg message handlers

BOOL CExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::LoadPclToPdfDll()
{
	m_hinstLib = LoadLibrary("pcltopdf.dll");
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMBegin = (MBegin *)GetProcAddress(m_hinstLib, "MBegin");
	if( pMBegin == NULL ){ 
		FreePclToPdfDll(); 
		return FALSE;
	}
	pMInputFiles = (MInputFiles *)GetProcAddress(m_hinstLib, "MInputFiles");
	if( pMInputFiles == NULL ){ 
		FreePclToPdfDll(); 
		return FALSE;
	}
	pMConvert = (MConvert *)GetProcAddress(m_hinstLib, "MConvert");
	if( pMConvert == NULL ){ 
		FreePclToPdfDll(); 
		return FALSE;
	}
	pMPdfSecurity = (MPdfSecurity *)GetProcAddress(m_hinstLib, "MPdfSecurity");
	if( pMPdfSecurity == NULL ){ 
		FreePclToPdfDll(); 
		return FALSE;
	}
	pMEnd = (MEnd *)GetProcAddress(m_hinstLib, "MEnd");
	if( pMEnd == NULL ){ 
		FreePclToPdfDll(); 
		return FALSE;
	}
	pMPdfInfo = (MPdfInfo *)GetProcAddress(m_hinstLib, "MPdfInfo");
	if( pMPdfInfo == NULL ){ 
		FreePclToPdfDll(); 
		return FALSE;
	}
	pMRegCode = (MRegCode *)GetProcAddress(m_hinstLib, "MRegCode");
	if( pMRegCode == NULL ){ 
		FreePclToPdfDll(); 
		return FALSE;
	}

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
BOOL CExampleDlg::FreePclToPdfDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton1() 
{
	if( LoadPclToPdfDll() == FALSE ){
		MessageBox("The file pcltopdf.dll Loading error!","Pcltopdf SDK",MB_OK);
		return;
	}

	long id = pMBegin();
	if(id<=0){
		MessageBox("PDF file create failed!","Pcltopdf SDK",MB_OK);
		FreePclToPdfDll();
		return;
	}	

	//add pcl files
	pMInputFiles(id,"pcl.pcl");
	pMInputFiles(id,"pcl2.pcl");

	//Trial version does not support PDF encryption!

	//Set pdf security
	long level=128;//40,128
	long permission=0;//Set restrictions for encryption.
	// 0 =	all allowed.
	// 4 =	Deny printing.
	// 8 =	Deny modification of contents.
	// 16 =	Deny copying of contents.
	// 32 =	No commenting.
	// 60 =	all disallowed.
	pMPdfSecurity(id,"password","password",level,permission);
	
	//Register your Pcltopdf SDK by the given Registration Key
	//pMRegCode(id,"AAAAAAAAAAAAAAAAAAAAAAAA");	
		
	//Set pdf info
	pMPdfInfo(id,"title","subject","author","keywords","creator");
	//convert
	long mode=1;//Combine all files into one pdf file
	char output[256];
	strcpy(output,"combine.pdf");
	pMConvert(id,mode,output);

	//end convert
	pMEnd(id);

	//free
	FreePclToPdfDll();
	MessageBox("Convert finished!","Pcltopdf SDK",MB_OK);
}
/////////////////////////////////////////////////////////////////////////////
void CExampleDlg::OnButton2() 
{
	if( LoadPclToPdfDll() == FALSE ){
		MessageBox("The file pcltopdf.dll Loading error!","Pcltopdf SDK",MB_OK);
		return;
	}

	long id = pMBegin();
	if(id<=0){
		MessageBox("PDF file create failed!","Pcltopdf SDK",MB_OK);
		FreePclToPdfDll();
		return;
	}	

	//add pcl files
	pMInputFiles(id,"pcl.pcl");
	pMInputFiles(id,"pcl2.pcl");

	//Trial version does not support PDF encryption!

	//Set pdf security
	long level=128;//40,128
	long permission=0;//Set restrictions for encryption.
	// 0 =	all allowed.
	// 4 =	Deny printing.
	// 8 =	Deny modification of contents.
	// 16 =	Deny copying of contents.
	// 32 =	No commenting.
	// 60 =	all disallowed.
	pMPdfSecurity(id,"password","password",level,permission);
	
	//Register your Pcltopdf SDK by the given Registration Key
	//pMRegCode(id,"AAAAAAAAAAAAAAAAAAAAAAAA");		
	
	//Set pdf info
	pMPdfInfo(id,"title","subject","author","keywords","creator");	

	//convert
	long mode=2;//Convert one file to one pdf file
	char output[256];
	strcpy(output,"outpath");
	pMConvert(id,mode,output);

	//end convert
	pMEnd(id);

	//free
	FreePclToPdfDll();
	MessageBox("Convert finished!","Pcltopdf SDK",MB_OK);
}
